Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## de.jstacs.classifier.scoringFunctionBased
Class OptimizableFunction

    java.lang.Object
      de.jstacs.algorithms.optimization.DifferentiableFunction
          de.jstacs.classifier.scoringFunctionBased.OptimizableFunction

All Implemented Interfaces:
  Function

Direct Known Subclasses:
  AbstractOptimizableFunction

    public abstract class OptimizableFunction

extends DifferentiableFunction

This is the main function for the `ScoreClassifier`.

Author:
  Jens Keilwagen
See Also:
  `Optimizer`

Nested Class Summary
`static class` | `OptimizableFunction.KindOfParameter` This enum defines the kinds of parameters that can be returned by the method `getParameters(KindOfParameter)`.

Constructor Summary
`OptimizableFunction()`

Method Summary
`abstract void` | `addTermToClassParameter(int classIndex, double term)` This method adds the `term` to the class parameter.
`abstract double[]` | `getClassParams(double[] params)` Returns from the complete vector of parameters those that are for the classes.
`abstract int` | `getNumberOfStarts()` Returns the number of starts that should be done for a good optimum.
`abstract double[]` | `getParameters(OptimizableFunction.KindOfParameter kind)` Returns some parameters that can be used for instance as start parameters.
`abstract void` | `reset(ScoringFunction[] score)` Resets the `ScoringFunction`s and all pre-computed values.
`abstract void` | `setParams(double[] current)` Sets the current values as parameters.

Methods inherited from class de.jstacs.algorithms.optimization.DifferentiableFunction
`evaluateGradientOfFunction, findOneDimensionalMin`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Methods inherited from interface de.jstacs.algorithms.optimization.Function
`evaluateFunction, getDimensionOfScope`

Constructor Detail

### OptimizableFunction

    public OptimizableFunction()

Method Detail

### getNumberOfStarts

    public abstract int getNumberOfStarts()

  Returns the number of starts that should be done for a good optimum. For concave or convex functions this number should be 1.

  Returns:
    the number of starts the `Optimizer` should be started to get a good optimum
  See Also:
    `Optimizer`

### getClassParams

    public abstract double[] getClassParams(double[] params)

  Returns from the complete vector of parameters those that are for the classes.

  Parameters:
    `params` - the current parameters
  Returns:
    the parameters for the classes

### getParameters

    public abstract double[] getParameters(OptimizableFunction.KindOfParameter kind)
                                    throws Exception

  Returns some parameters that can be used for instance as start parameters.

  Parameters:
    `kind` - the kind of the class parameters that will be returned
  Returns:
    some start parameters
  Throws:
    `Exception` - if something went wrong

### setParams

    public abstract void setParams(double[] current)
                            throws DimensionException

  Sets the current values as parameters.

  Parameters:
    `current` - the current values
  Throws:
    `DimensionException` - if the dimension of the current values does not match with the internal parameters

### reset

    public abstract void reset(ScoringFunction[] score)
                        throws Exception

  Resets the `ScoringFunction`s and all pre-computed values.

  Parameters:
    `score` - the array of `ScoringFunction`s
  Throws:
    `Exception` - if something went wrong

### addTermToClassParameter

    public abstract void addTermToClassParameter(int classIndex,
                                                 double term)

  This method adds the `term` to the class parameter.

  Parameters:
    `classIndex` - the index of the class
    `term` - the term to be added

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD